unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldblib, sqldb, db, sqlite3conn, FileUtil, Forms,
  Controls, Graphics, Dialogs, StdCtrls, DBGrids, ZDataset, ZConnection,
  VpFlxDS, VpWeekView, VpContactGrid, VpBaseDS, VpContactEditDlg,
  VpContactButtons, VpResEditDlg, VpData, VpPrtFmtDlg, VpDayView, VpAlarmDlg,
  VpEvntEditDlg, VpTaskEditDlg, VpPrtFmtCBox, VpCalendar;

type

  { TFormMain }

  TFormMain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    VpCalendar1: TVpCalendar;
    VpDayView1: TVpDayView;
    VpPrintFormatComboBox1: TVpPrintFormatComboBox;
    VpTaskEditDialog1: TVpTaskEditDialog;
    ZDSReg: TDatasource;
    ZDSEvent: TDatasource;
    ZDSTask: TDatasource;
    ZDSRes: TDatasource;
    ZDSCont: TDatasource;
    VpContactButtonBar1: TVpContactButtonBar;
    VpContactEditDialog1: TVpContactEditDialog;
    VpCGrid1: TVpContactGrid;
    VpControlLink1: TVpControlLink;
    VpEventEditDialog1: TVpEventEditDialog;
    DataStore: TVpFlexDataStore;
    VpPrintFormatEditDialog1: TVpPrintFormatEditDialog;
    VpResourceCombo1: TVpResourceCombo;
    VpResourceEditDialog1: TVpResourceEditDialog;
    VpWeekView1: TVpWeekView;
    ZCon: TZConnection;
    ZTRecord: TZTable;
    ZTTasks: TZTable;
    ZTContacts: TZTable;
    ZTEvents: TZTable;
    ZTResources: TZTable;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure VpCGrid1OwnerEditContact(Sender: TObject; Contact: TVpContact;
      Resource: TVpResource; var AllowIt: Boolean);
    procedure DataStoreAfterPostResources(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormMain: TFormMain;

implementation
 uses fdlgresedit;
{$R *.lfm}

{ TFormMain }

procedure TFormMain.FormCreate(Sender: TObject);
var DBParams:TStringList;
    DbPath,fName :String;
begin
   try
       DbPath :=GetCurrentDir+'\datas' ;
       if not DirectoryExists(DbPath) then
         If Not CreateDir ('datas') Then
           ShowMessage('Failed to create directory !');
       ZCon.Database:='';
       fName := ExtractFilePath(ParamStr(0)) +'datas\maintance.db3';
       if not FileExists(fName) then
        begin
         ZCon.Database:=fName;
         ZCon.Connected:=true;
         ZCon.ExecuteDirect('create Table CONTACTS ('+
            'RECORDID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
            'RESOURCEID INTEGER,'+
            'FIRSTNAME VARCHAR(50) ,'+
            'LASTNAME VARCHAR(50) , '+
            'BIRTHDATE DATE, '+
            'ANNIVERSARY DATE,'+
            'TITLE VARCHAR(50) ,'+
            'COMPANY VARCHAR(50) ,'+
            'MYPOSITION VARCHAR(30),'+
            'EMAIL VARCHAR(50) ,'+
            'ADRESS VARCHAR(50) ,'+
            'CITY VARCHAR(50) , '+
            'STATE VARCHAR(50) ,'+
            'ZIP VARCHAR(50) , '+
            'COUNTRY VARCHAR(50) ,'+
            'NOTE VARCHAR(50) , '+
            'PHONE1 VARCHAR(50) ,'+
            'PHONE2 VARCHAR(50) ,'+
            'PHONE3 VARCHAR(50) ,'+
            'PHONE4 VARCHAR(50) ,'+
            'PHONE5 VARCHAR(50) , '+
            'PHONETYPE1 VARCHAR(50) ,'+
            'PHONETYPE2 VARCHAR(50) ,'+
            'PHONETYPE3 VARCHAR(50) , '+
            'PHONETYPE4 VARCHAR(50) , '+
            'PHONETYPE5 VARCHAR(50) , '+
            'CATEGORY VARCHAR(50) ,  '+
            'CUSTOM1 VARCHAR(50) , '+
            'CUSTOM2 VARCHAR(50) ,'+
            'CUSTOM3 VARCHAR(50) , '+
            'CUSTOM4 VARCHAR(50) , '+
            'USERFIELD0 VARCHAR(50) ,'+
            'USERFIELD1 VARCHAR(50) ,'+
            'USERFIELD2 VARCHAR(50) ,'+
            'USERFIELD3 VARCHAR(50) ,'+
            'USERFIELD4 VARCHAR(50) ,'+
            'USERFIELD5 VARCHAR(50) ,'+
            'USERFIELD6 VARCHAR(50) ,'+
            'USERFIELD7 VARCHAR(50) ,'+
            'USERFIELD8 VARCHAR(50) ,'+
            'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table EVENTS ('+
             'RECORDID  INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
             'STARTTIME TIMESTAMP,'+
             'ENDTIME TIMESTAMP, '+
             'RESOURCEID INTEGER,'+
             'DESCRIPTION VARCHAR(500) ,'+
             'NOTE VARCHAR(500) ,'+
             'CATEGORY VARCHAR(50) ,'+
             'ALLDAYEVENT VARCHAR(50) ,'+
             'ALARMWAVPATH VARCHAR(50) ,'+
             'ALARMSET VARCHAR(50) ,'+
             'ALARMADV INTEGER ,'+
             'ALARMADVTYPE INTEGER ,'+
             'SNOOZETIME VARCHAR(50) ,'+
             'REPEATCODE VARCHAR(50) ,'+
             'REPEATRANGEEND VARCHAR(50) ,'+
             'CUSTINTERVAL INTEGER ,'+
             'USERFIELD0 VARCHAR(50) ,'+
             'USERFIELD1 VARCHAR(50) ,'+
             'USERFIELD2 VARCHAR(50) ,'+
             'USERFIELD3 VARCHAR(50) ,'+
             'USERFIELD4 VARCHAR(50) ,'+
             'USERFIELD5 VARCHAR(50) ,'+
             'USERFIELD6 VARCHAR(50) ,'+
             'USERFIELD7 VARCHAR(50) ,'+
             'USERFIELD8 VARCHAR(50) ,'+
             'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table RESOURCES ( '+
              'RESOURCEID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
              'DESCRIPTION VARCHAR(500) ,'+
              'NOTES VARCHAR(50) , '+
              'IMAGEINDEX INTEGER,'+
              'ACTIVE VARCHAR(50) ,'+
              'USERFIELD0 VARCHAR(50) ,'+
              'USERFIELD1 VARCHAR(50) ,'+
              'USERFIELD2 VARCHAR(50) ,'+
              'USERFIELD3 VARCHAR(50) ,'+
              'USERFIELD4 VARCHAR(50) ,'+
              'USERFIELD5 VARCHAR(50) ,'+
              'USERFIELD6 VARCHAR(50) ,'+
              'USERFIELD7 VARCHAR(50) ,'+
              'USERFIELD8 VARCHAR(50) ,'+
              'USERFIELD9 VARCHAR(50))');

         ZCon.ExecuteDirect('create table TASKS ('+
               'RECORDID INTEGER not null PRIMARY KEY AUTOINCREMENT,'+
               'RESOURCEID INTEGER,'+
               'COMPLETE TIMESTAMP ,'+
               'DESCRIPTION VARCHAR(500) ,'+
               'DETAILS VARCHAR(50) ,'+
               'CREATEDON TIMESTAMP ,'+
               'COMPLETEDON TIMESTAMP ,'+
               'PRIORITY VARCHAR(50) ,'+
               'CATEGORY VARCHAR(50) ,'+
               'DUEDATE TIMESTAMP ,'+
               'USERFIELD0 VARCHAR(50) ,'+
               'USERFIELD1 VARCHAR(50) ,'+
               'USERFIELD2 VARCHAR(50) ,'+
               'USERFIELD3 VARCHAR(50) ,'+
               'USERFIELD4 VARCHAR(50) ,'+
               'USERFIELD5 VARCHAR(50) ,'+
               'USERFIELD6 VARCHAR(50) ,'+
               'USERFIELD7 VARCHAR(50) ,'+
               'USERFIELD8 VARCHAR(50) ,'+
               'USERFIELD9 VARCHAR(50)) ');

          ZCon.ExecuteDirect('create table record( resourceid integer not null primary key,EventId integer, TaskId integer, ContactId Integer, UserField nvarchar(20))');


         ZCon.Connected:=true;
         ZTRecord.Active:=true;
        end
       else
        begin
         ZCon.Database:=fname;

         If ZCon.Connected = false then begin
            ZCon.Connected:=true;
         end;

     end;
        ZCon.Connected:=true;
        DataStore.Connected:=true;
   except
       showmessage('Conect to Db was not sucesfull');
     end;

end;

procedure TFormMain.Button1Click(Sender: TObject);
begin
  // VpresourceEditDialog1.lblDescription.Caption:='Doctor';
   VpresourceEditDialog1.AddNewResource
end;

procedure TFormMain.Button2Click(Sender: TObject);
var  Contac:TVpContact ;
begin
     if not VPContactEditDialog1.AddNewContact() then begin
        showmessage('Was not possible add new contact');
     end;

end;

procedure TFormMain.Button3Click(Sender: TObject);
var
  Task: TVpTask;

begin

//  VpTaskEditDialog1.AddNewTask;
   Task := DataStore.Resource.Tasks.AddTask(DataStore.GetNextID('Tasks'));
   Task.CreatedOn:=now;
   Task.DueDate:=Task.CreatedOn+7;
   if VpTaskEditDialog1.AddNewTask then
         DataStore.PostTasks;

end;

procedure TFormMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  DataStore.Connected:=false;
 // DataStore.Free;
  ZCon.Connected:=false;
//  ZCon.Free;
end;

procedure TFormMain.FormShow(Sender: TObject);
Var Id:Integer;
    Qry: TSQLQuery;
begin
  VpResourceEditDialog1.DataStore.Load;
  VpResourceEditDialog1.DataStore.SetResourceByName('Default')
end;

procedure TFormMain.VpCGrid1OwnerEditContact(Sender: TObject;
  Contact: TVpContact; Resource: TVpResource; var AllowIt: Boolean);
begin

end;

procedure TFormMain.DataStoreAfterPostResources(Sender: TObject);
begin
   vpResourceEditDialog1.Execute  ;

end;


end.

